import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClassroomquestionpackageitem {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  ClassRoomQuestionPackageId!: IType<number, bigint>;
  BookId!: IType<number, bigint>;
  ClassRoomCourseId!: IType<number, bigint>;
  Type!: number;
  BookPageId?: IType<number, bigint>;
  BookQuestionId?: IType<number, bigint>;
  QestionUrl?: string;
  RightOptions?: string;
  Sort!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrClassroomquestionpackageitemSchema = defineEntity({
  class: IcrClassroomquestionpackageitem,
  comment: '课堂问题项',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    ClassRoomQuestionPackageId: p.bigint().name('ClassRoomQuestionPackageId').columnType('bigint').comment('问题包Id'),
    BookId: p.bigint().name('BookId').columnType('bigint').comment('书籍Id'),
    ClassRoomCourseId: p.bigint().name('ClassRoomCourseId').columnType('bigint').comment('课程Id'),
    Type: p.integer().name('Type').comment('问题包类型'),
    BookPageId: p.bigint().name('BookPageId').columnType('bigint').nullable().comment('书籍页Id'),
    BookQuestionId: p.bigint().name('BookQuestionId').columnType('bigint').nullable().comment('书籍问题Id'),
    QestionUrl: p.string().name('QestionUrl').nullable().comment('问题路径'),
    RightOptions: p.string().name('RightOptions').nullable().comment('正确选项'),
    Sort: p.integer().name('Sort').comment('排序字段'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
